booster::recursive_shared_mutex Class Reference

Recursuve Shared mutex or a.k.a. Read-Write Lock that can be recursively locked by readers. More...

`#include <booster/booster/thread.h>`

Inheritance diagram for booster::recursive_shared_mutex:

## Public Member Functions

void | lock ()
void | unique_lock ()
void | shared_lock ()
void | unlock ()

## Detailed Description

Recursuve Shared mutex or a.k.a. Read-Write Lock that can be recursively locked by readers.

This class provides two options of locking unique - nobody but me can use the object shared anybody with shared lock can use the object.

## Member Function Documentation

void booster::recursive_shared_mutex::lock | ( |  | ) |

inline

Same as unique_lock()

Note
  this function is not recursive

void booster::recursive_shared_mutex::shared_lock | ( |  | ) |

Acquire a shared lock on the object.

See Also
  booster::shared_lock

Note
  the shared_lock() member function is recursive, that means that same thread may acquire it multiple times.

void booster::recursive_shared_mutex::unique_lock | ( |  | ) |

Acquire a unique lock on the object.

See Also
  booster::unique_lock

Note
  this function is not recursive

void booster::recursive_shared_mutex::unlock | ( |  | ) |

Release the lock

The documentation for this class was generated from the following file:

- booster/thread.h